options(error = function() {
  traceback(2)
  if ( !interactive() )
  {
    q("no", status = 1, runLast = FALSE)
  }
  })


#сюда папку со скриптами(hmisc.r и т.д.)
scriptsPrefix = ""
#Encoding(scriptsPrefix) <- "UTF-8"

#v.1.0 01.03.16

#save.image(file = fS)
if(!exists("Open")) return;
if(!exists("ch1")) ch1 <-z
if(!exists("ch2")) ch2 <-z
if (!exists("sync_ch")) sync_ch = F
curAcc <- list()  #only computed when first=FALSE, init for availability
curAcc$Acc <- 0.0
curLabel <- list()
if(first)
{
	#-- Load the library and functions
	packets <- c("magrittr", "dplyr", "markovchain", "TTR", "caret", "rminer", "pracma", 
						"randomUniformForest", "deepnet", "Hmisc", "mhsmm", "fTrading")
	for(i in 1:length(packets)) {
	  if (! (packets[i] %in% rownames(installed.packages()))) { 
		install.packages(packets[i]) }
	}
	library(magrittr)
	library(dplyr)
	#------SetDir-------
	
	if(!exists("Open")) return;
	source(paste0(scriptsPrefix, '/SetDir.r'))
	source(paste0(scriptsPrefix, '/hmisc.r'))
	source(paste0(scriptsPrefix, '/e_DNSAE_FUN_prob.r'))
	if(!exists("Open")) return;
	#===========Calculate=========================================
	#1----We form a matrix of quotations -------------------
	price <- pr.OHLC(Open, High, Low, Close);
	#save.image(file = fS)
	#rm(list=c("Open","High","Low","Close"));
	#n = 34; z = 37;  soft = TRUE
	cut = 0.9
	

	method = c("center", "spatialSign")
	#method = c("center", "scale","spatialSign")
	#method = c("center", "scale")
		
	#best <- prepareBest(n = n, z = z, cut = cut, norm = T, method)
	data.f <- form.data(n = n, z = z, len = length(Open))
	best <- colnames(data.f) %>% head(.,ncol(data.f)-1)
	
	#data.f <- uniqueTD2(data.f, best)
	
	#best <- colnames(data.f) %>% head(.,ncol(data.f)-1)
	DT <- prepareTrain(x = data.f[ ,best], 
					   y = data.f$y, 
					   balance = FALSE, 
					   rati = 100, #rati = 4/5,
					   mod = "order", 
					   norm = TRUE, meth = method)
	
	#DT$train <- uniqueTD(DT$train, best)
	
	modelType <- "NN" #NN, MACDOpt
	if (modelType == "NN")
	{
	  SAE <-
	    train_SAE(
	      DT,
	      Ep = 50,
	      Bs = 50,
	      bst = best,
	      sig_type = 16
	    ) ##Ep=250
	  
	  resAcc <- testAcc(SAE, tail(DT$test,500))
	  DT_for_tb <- list(test = NULL)
	  DT_for_tb$test <- prepareTest(n, z, TRUE)
	  resBal <- testBal(SAE, , DT, best)
	  resAccTBData <- testAcc(SAE, DT_for_tb$test)
	  # корректируем сигнал по линии баланса
	  sig <- resBal$sig
	  sig.pr <- correct(sig) %>% extract2('sig.c')##%>% pred.sig()
	  # Результирующий вектор сигналов для эксперта
	  S <- sig.pr * tail(sig, length(sig.pr))
	  Kmax <- corr$Kmax %>% round()
	  K <- corr$K %>% round()
	  maxDD <- (corr$dd$maxdrawdown * (10 ^ Dig)) %>% round()
	  # корректируем сигнал сглаживание HMM
	  #sig <- resBal$sig
	  #sig.sm <- smoooth(sig)
	  # Результирующий вектор сигналов для эксперта
	  #S <- sig.sm$sig
	  #Kmax <- sig.sm$Kmax
	  #K <- sig.sm$K
	  #maxDD <- (sig.sm$dd$maxdrawdown*(10 ^ Dig))%>% round()
	  #if(K >= Kmin){first = FALSE}
	  
	  rm('DT_for_tb')
	}
	
	if ( modelType == "MACDOpt" )
	{
	  macdBestParams <- MACDOpt()
	  sig <- MACDSignal(macdBestParams$par)$sig
	  K <- fitnes(macdBestParams$par)
	  Kmax <- 0
	  maxDD <- 0
	}
	
	first = FALSE
	rm(list = c('data.f', 'DT' ))
	#---Write image
	save.image(file = fS)
	
	S <- sig ##Disabling correction
}else{
	price <- pr.OHLC(Open, High, Low, Close);
	#rm(list=c("Open","High","Low","Close"));
	#save.image(file = fS)
	
	if(modelType == "NN")
	{
	  DT_for_tb <- list(test = NULL)
	  DT_for_tb$test <-
	    prepareTest(n, z, TRUE) ##в compare.zip было DT.test <- prepareTest(n, z, TRUE, len = length(Open)+1)
	  resBal <- testBal(SAE, , DT_for_tb, best)
	  sig <- resBal$sig
	  sig.pr <- correct(sig) %>% extract2('sig.c')##%>% pred.sig()
	  ##sig.pr <- pred.sig(sig)
	  # Результирующий вектор сигналов для эксперта
	  S <- sig.pr * tail(sig, length(sig.pr))
	  Kmax <- corr$Kmax %>% round()
	  K <- corr$K %>% round()
	  maxDD <- (corr$dd$maxdrawdown * (10 ^ Dig)) %>% round()
	  #
	  #dataForAcc <- tail( form.data(n = n, z = z, len = 100), 100 )
	  #tmp <- prepareTest(n, z, TRUE, 100)
	  #dataForAcc <- cbind(tmp, y=dataForAcc[ ,"y"])
	  #curAcc <- testAcc(SAE, dataForAcc)
	  #curLabel <- subtract( as.integer( dataForAcc[,"y"] ), 1 )
	  #
	  
	  S <- sig
	  Kmax <- resBal$Kmax
	  K <- resBal$K
	  maxDD <- (resBal$dd$maxdrawdown * (10 ^ Dig)) %>% round()
	  #if(K < Kmin){first = TRUE}
	  if(K < 3){first = TRUE}
	  #---Write image
	  save.image(file = fS)
	}
	
	if (modelType == "MACDOpt")
	{
	  MACDPreparePr()
	  sig <- MACDSignal(macdBestParams$par)$sig
	  K <- fitnes(macdBestParams$par)
	  Kmax <- 0
	  maxDD <- 0
	  S <- sig
	}
	
	#S <- sig ##Disabling correction
}